%% Clean up working area
clear all
close all
clc

%% 0. Do comment your code
% This is a comment

disp('Hello World!');   % This is an unformatted output

%% 1. Loading data

% 1a) Load handel using the command "load". Check the content of the
% variables loaded.
load handel

% 1b) Play the variable y
% doc sound (most important command!)
sound(y);

% 1c) Save the imported variables
save hallelujah.mat

% 1d) Load the variables saved in "ex0.mat"
save ex0.mat

%% 2- Vectors/matrices

% 2a- Create a column vector x with the numbers 1, 3, 5, 7, ..., 99
% Tip: use the operator ":" to make row vectors
x = (1:2:99)'   % output to command line
x = (1:2:99)';  % no output to command line

% 2b- Make a column vector "y", 50 x 1, with all zero elements except for
% the 10th element, which is 1.
y = [zeros(9,1) ; 1 ; zeros(40,1)];
% OR %
y = zeros(50,1);
y(10) = 1;

% 2c- Declare matrix "A", 4 x 3:
%       [2  4   7 3]
%       |1 -1 -10 9|
%       |5 -3   2 0|
A = [2  4   7 3 ;
     1 -1 -10 9 ;
     5 -3   2 0];
% OR %
A = [2 4 7 3 ; 1 -1 -10 9 ; 5 -3 2 0];

% 2d- Create a 5 x 5 identity matrix "I"
I = eye(5);


%% 3- Operations with vectors/matrices

% 3a- Evaluate the inner product of "x" and "y"
% (Think about what the result should be!)
m = x'*y;

% 3b- Evaluate the product between matrix "A" and vector "v"
n = A*v;

% 3c- Define the vetor p, 1 x 100, so that
% p = [ sin(0.2*0) sin(0.2*1) ... sin(0.2*49) sin(0.5*50) ... sin(0.5*99) ]
%                                       ^           ^
% Attention! Note that the sinusoid frequency changes at element 51!

% Tip: Use the "sin" function which can be applied to vectors (see help);
%        find out what the element-wise product ".*" is and use it!
% Attention: The operator ":" creates ROW vectors
p = sin( [0.2*ones(1,50) 0.5*ones(1,50)] .* (0:99) );


%% 4- Logic indexing

% 4a- Find out how many elements of "q" are between 0.1 and 0.3.
% (larger than or equal to 0.1 e less than or equal to 0.3).
%
% Tip: Don't do it by hand!!
% [ http://blogs.mathworks.com/loren/2013/02/20/logical-indexing-multiple-conditions/ ]
count = sum(q <= 0.3 & q >= 0.1);


% 4b- Find out the index of the largest element of the vector
%
% Tip: Don't do it by hand!! (try help max)
% [ http://blogs.mathworks.com/loren/2013/02/20/logical-indexing-multiple-conditions/ ]
largest = find(q == max(q));
% OR %
[~,largest] = max(q);


%% 5- Functions

% 5a- Create a function in the file "randoms.m" which takes an integer and
% returns two COLUMN vectors
%   - "s": M uniform random numbers between 0 and 1;
%           Tip: help rand
%   - "t": M uniform random integers between 1 and 6;
%           Dica: help randi
[s, t] = randoms_answer( 10 );


%% 6- Flow Control
% 6a) Display whether count is larger than 15
if (count > 15)
    disp('count is greater than 15');
else
    disp('count is not greater than 15');
end

% 6b) Say OK if count is larger than 10 and largest is equal to 5
% Tip: use logical operators: && == <= >= ~=
if ((count > 10) && (larger == 5))
    disp('OK!');
end

% 6c) Make a for loop that creates a variable z with elements from 1 to 10
for i = 1:10
    z(i) = i;
end


%% 7- Plots

% 7a) Plot the vectors p and q by their indices (from 1 to 100).
%     Make it look like Figure 1.
figure();
% INSERT CODE HERE %%%%%%%%%%%%%%%%%%%%
stem(1:100, p);
hold on;
plot(1:100, q, 'x--');
xlabel('Index');
ylabel('Magnitude');
title('Vectors p (deterministic) and q (random)');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

